//----------------------------------------------------------------------------------
//Isophote tB^ AviUtl
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA, or visit
// http://www.gnu.org/copyleft/gpl.html .
//
// Original AviSynth version
// TIsophote.dll
// http://www.missouri.edu/~kes25c/
//----------------------------------------------------------------------------------
#include <windows.h>

#include "filter.h"
#include <float.h>

#include <omp.h>

//#define GET_TIME
#ifdef GET_TIME
#include <sstream>
#include <mmsystem.h>
#pragma comment( lib, "winmm.lib" )
#endif
//---------------------------------------------------------------------
//		tB^\̒`
//---------------------------------------------------------------------
#define	TRACK_N	3														//	gbNo[̐
TCHAR	*track_name[] =		{	"",	"W",	"Mode"	};	//	gbNo[̖O
int		track_default[] =	{	4,		20,		1,		};	//	gbNo[̏l
int		track_s[] =			{	1,		1,		0,		};	//	gbNo[̉l
int		track_e[] =			{	32,		100,	2,		};	//	gbNo[̏l

#define	CHECK_N	1														//	`FbN{bNX̐
TCHAR	*check_name[] = 	{	"Px̂"	};							//	`FbN{bNX̖O
int		check_default[] = 	{	1			};							//	`FbN{bNX̏l (l01)

FILTER_DLL filter = {
	FILTER_FLAG_EX_INFORMATION,	//	tB^̃tO
								//	FILTER_FLAG_ALWAYS_ACTIVE		: tB^ɃANeBuɂ܂
								//	FILTER_FLAG_CONFIG_POPUP		: ݒ|bvAbvj[ɂ܂
								//	FILTER_FLAG_CONFIG_CHECK		: ݒ`FbN{bNXj[ɂ܂
								//	FILTER_FLAG_CONFIG_RADIO		: ݒWI{^j[ɂ܂
								//	FILTER_FLAG_EX_DATA				: gf[^ۑo悤ɂ܂B
								//	FILTER_FLAG_PRIORITY_HIGHEST	: tB^̃vCIeBɍŏʂɂ܂
								//	FILTER_FLAG_PRIORITY_LOWEST		: tB^̃vCIeBɍŉʂɂ܂
								//	FILTER_FLAG_WINDOW_THICKFRAME	: TCYύX\ȃEBhE܂
								//	FILTER_FLAG_WINDOW_SIZE			: ݒEBhẼTCYwo悤ɂ܂
								//	FILTER_FLAG_DISP_FILTER			: \tB^ɂ܂
								//	FILTER_FLAG_EX_INFORMATION		: tB^̊gݒł悤ɂ܂
								//	FILTER_FLAG_NO_CONFIG			: ݒEBhE\Ȃ悤ɂ܂
								//	FILTER_FLAG_AUDIO_FILTER		: I[fBItB^ɂ܂
								//	FILTER_FLAG_RADIO_BUTTON		: `FbN{bNXWI{^ɂ܂
								//	FILTER_FLAG_WINDOW_HSCROLL		: XN[o[EBhE܂
								//	FILTER_FLAG_WINDOW_VSCROLL		: XN[o[EBhE܂
								//	FILTER_FLAG_IMPORT				: C|[gj[܂
								//	FILTER_FLAG_EXPORT				: GNX|[gj[܂
	0,0,						//	ݒEChẼTCY (FILTER_FLAG_WINDOW_SIZEĂ鎞ɗL)
	"Isophote",			//	tB^̖O
	TRACK_N,					//	gbNo[̐ (0Ȃ疼OlNULLł悢)
	track_name,					//	gbNo[̖OSւ̃|C^
	track_default,				//	gbNo[̏lSւ̃|C^
	track_s,track_e,			//	gbNo[̐l̉ (NULLȂS0`256)
	CHECK_N,					//	`FbN{bNX̐ (0Ȃ疼OlNULLł悢)
	check_name,					//	`FbN{bNX̖OSւ̃|C^
	check_default,				//	`FbN{bNX̏lSւ̃|C^
	func_proc,					//	tB^֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	JnɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	IɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	ݒ肪ύXꂽƂɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	ݒEBhEɃEBhEbZ[WɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,NULL,					//	VXeŎg܂̂ŎgpȂł
	NULL,						//  gf[^̈ւ̃|C^ (FILTER_FLAG_EX_DATAĂ鎞ɗL)
	NULL,						//  gf[^TCY (FILTER_FLAG_EX_DATAĂ鎞ɗL)
	"IsophotetB^ version 0.01",
								//  tB^ւ̃|C^ (FILTER_FLAG_EX_INFORMATIONĂ鎞ɗL)
	NULL,						//	Z[uJn钼OɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	Z[uIOɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
};


//---------------------------------------------------------------------
//		tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
	return &filter;
}



PIXEL_YC operator+ (const PIXEL_YC& src1,const PIXEL_YC& src2)
{
	PIXEL_YC ret;
	ret.y = src1.y+src2.y;
	ret.cr = src1.y+src2.cr;
	ret.cb = src1.y+src2.cb;
	return ret;
}

PIXEL_YC operator- (const PIXEL_YC& src1,const PIXEL_YC& src2)
{
	PIXEL_YC ret;
	ret.y = src1.y-src2.y;
	ret.cr = src1.y-src2.cr;
	ret.cb = src1.y-src2.cb;
	return ret;
}
PIXEL_YC operator* (const PIXEL_YC& src1,const PIXEL_YC& src2)
{
	PIXEL_YC ret;
	ret.y = src1.y*src2.y;
	ret.cr = src1.y*src2.cr;
	ret.cb = src1.y*src2.cb;
	return ret;
}
PIXEL_YC operator/ (const PIXEL_YC& src1,const PIXEL_YC& src2)
{
	PIXEL_YC ret;
	ret.y = src1.y/src2.y;
	ret.cr = src1.y/src2.cr;
	ret.cb = src1.y/src2.cb;
	return ret;
}

PIXEL_YC& operator+= (PIXEL_YC& dst,const PIXEL_YC& src)
{
	dst.y += src.y;
	dst.cr += src.cr;
	dst.cb += src.cb;
	return dst;
}
PIXEL_YC& operator+= (PIXEL_YC& dst,const int src)
{
	dst.y += src;
	return dst;
}
PIXEL_YC& operator-= (PIXEL_YC& dst,const PIXEL_YC& src)
{
	dst.y -= src.y;
	dst.cr -= src.cr;
	dst.cb -= src.cb;
	return dst;
}


const double off = DBL_EPSILON;
inline int ishophote1(short _pp, short _pc, short _pn, short _cp, short _cc, short _cn, short _np,short _nc, short _nn ,double Step)
{
	//12bitI[o[t[
	int Ix = _cn - _cp;
	double Ix2 = Ix * Ix;
	int Iy = _nc - _pc;
	double Iy2 = Iy * Iy;

	double d = ( Ix2 + Iy2 ) * 2 +off;//24+1+1
	
	int Icc2 = _cc * 2;
	double Ixy = _pp - _pn - _np  + _nn;
	int Ixx = _cn + _cp - Icc2;
	int Iyy = _pc + _nc - Icc2;
	double IxIyIxy = Ix*Iy*Ixy;//12+12+12	
	double u =( (Ix2*Iyy) - IxIyIxy + (Iy2*Ixx))* Step;
	return _cc + static_cast< int >( u / d + 0.5 );
}

inline int ishophote2(short _pp, short _pc, short _pn, short _cp, short _cc, short _cn, short _np,short _nc, short _nn ,double Step)
{
	int Ix = _pn + 2 * _cp + _nn - _pp - 2 * _cp - _np;
	double Ix2 = Ix * Ix;
	int Iy = _np + 2 * _nc + _nn - _pp - 2 * _pc - _pn;
	double Iy2 = Iy * Iy;

	double d = ( Ix2 + Iy2 ) * 2 +off;//24+1+1
	
	int Icc2 = _cc * 2;
	double Ixy = _pp - _pn - _np  + _nn;
	int Ixx = _cn + _cp - Icc2;
	int Iyy = _pc + _nc - Icc2;
	double IxIyIxy = Ix*Iy*Ixy;//12+12+12	
	double u =( (Ix2*Iyy) - IxIyIxy + (Iy2*Ixx))* Step;
	return _cc + static_cast< int >( u / d + 0.5 );
}

inline int ishophote3(short _pp, short _pc, short _pn, short _cp, short _cc, short _cn, short _np,short _nc, short _nn ,double Step)
{
	int Ix = _pn + 2 * _cn + _nn - _pp - 2 * _cp - _np;
	double Ix2 = Ix * Ix;
	int Iy = _np + 2 * _nc + _nn - _pp - 2 * _pc - _pn;
	double Iy2 = Iy * Iy;

	double d = ( Ix2 + Iy2 ) * 2 +off;//24+1+1

	int Icc2 = _cc * 2;
	double Ixy = _pp - _pn - _np  + _nn;
	int Ixx = _cn + _cp - Icc2;
	int Iyy = _pc + _nc - Icc2;
	double IxIyIxy = Ix*Iy*Ixy;//12+12+12	
	double u =( (Ix2*Iyy) - IxIyIxy + (Iy2*Ixx))* Step;
	return _cc + static_cast< int >( u / d + 0.5 );
}

template<typename _T, _T _min, _T _max> inline _T Round( _T value )
{
	
	if( _min > value ){	return _min;	}
	if( _max < value ){ return _max;	}
	return value;

}


//---------------------------------------------------------------------
//		tB^֐
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp,FILTER_PROC_INFO *fpip )
{
//
//	fp->track[n]			: gbNo[̐l
//	fp->check[n]			: `FbN{bNX̐l
//	fpip->w 				: ۂ̉摜̉
//	fpip->h 				: ۂ̉摜̏c
//	fpip->max_w				: 摜̈̉
//	fpip->max_h				: 摜̈̏c
//	fpip->ycp_edit			: 摜̈ւ̃|C^
//	fpip->ycp_temp			: e|̈ւ̃|C^
//	fpip->ycp_edit[n].y		: f(Px    )f[^ (     0 ` 4096 )
//	fpip->ycp_edit[n].cb	: f(F())f[^ ( -2048 ` 2048 )
//	fpip->ycp_edit[n].cr	: f(F())f[^ ( -2048 ` 2048 )
//
//  ff[^͔͈͊OɏoĂ邱Ƃ܂B
//  ܂͈͓Ɏ߂ȂĂ܂܂B
//
//	摜TCYςƂ fpip->w  fpip->h ς܂B
//
//	e|̈ɏ摜i[Ƃ
//	fpip->ycp_edit  fpip->ycp_temp ւ܂B
//
#ifdef GET_TIME

	FILETIME dumy, start, end;
	timeBeginPeriod( 1 ) ; 
	DWORD  start_time = timeGetTime();
	GetThreadTimes( GetCurrentThread(), &dumy, &dumy, &dumy, &start);
#endif
	const int iterations = fp->track[0];
	const double Step = fp->track[1] / 100.0;
	const int mode = fp->track[2];
	const int pitch = fpip->max_w; 
	const bool is_y_only = fp->check[ 0 ] != 0;



	const PIXEL_YC* src;
	PIXEL_YC* dst;
	const int width = fpip->w-1;
	const int height = fpip->h-1;

	if( is_y_only )
	{
		{
			#pragma omp parallel for
			for( int y = 0; y < fpip->h ; ++y )
			{
				int offset = y*pitch;
				memcpy( fpip->ycp_temp + offset, fpip->ycp_edit + offset , sizeof(PIXEL_YC)*fpip->w );
			}
		}

		if( mode == 0 )
		{
			for(int i = 0 ; i<= iterations ; ++i)
			{
				if( i & 1 )
				{
					src = fpip->ycp_temp;
					dst = fpip->ycp_edit;
				}
				else
				{
					src = fpip->ycp_edit;
					dst = fpip->ycp_temp;
				}
				
				for(int y = 1 ; y < height; ++y)
				{
					int addr = y * pitch;
					#pragma omp parallel for
					for( int x = 1 ; x < width ; ++x )
					{
						int cc = addr + x;
						int pc = cc - pitch;
						int pp = pc-1;
						int pn = pc+1;
						int cp = cc -1;
						int cn = cc +1;
						int nc = cc + pitch;
						int np = nc-1;
						int nn = nc+1;

						dst[ cc ].y  = Round< short, 0, 4096 >( 
							ishophote1(
								src[ pp ].y , src[ pc ].y , src[ pn ].y,
								src[ cp ].y , src[ cc ].y , src[ cn ].y, 
								src[ np ].y , src[ nc ].y , src[ nn ].y, Step )
							);
					}
				
				}//y
			}//itr
		}
		else if ( mode ==1 )
		{
			for(int i = 0 ; i<= iterations ; ++i)
			{
				if( i & 1 )
				{
					src = fpip->ycp_temp;
					dst = fpip->ycp_edit;
				}
				else
				{
					src = fpip->ycp_edit;
					dst = fpip->ycp_temp;
				}
				for(int y = 1 ; y < height; ++y)
				{
					int addr = y * pitch;
					#pragma omp parallel for
					for( int x = 1 ; x < width ; ++x )
					{
						int cc = addr + x;
						int pc = cc - pitch;
						int pp = pc-1;
						int pn = pc+1;
						int cp = cc -1;
						int cn = cc +1;
						int nc = cc + pitch;
						int np = nc-1;
						int nn = nc+1;

						dst[ cc ].y  = Round< short, 0, 4096 >( 
							ishophote2(
								src[ pp ].y , src[ pc ].y , src[ pn ].y,
								src[ cp ].y , src[ cc ].y , src[ cn ].y, 
								src[ np ].y , src[ nc ].y , src[ nn ].y, Step )
							);
					}
				
				}
			}//itr
		
		}
		else
		{
			for(int i = 0 ; i<= iterations ; ++i)
			{
				if( i & 1 )
				{
					src = fpip->ycp_temp;
					dst = fpip->ycp_edit;
				}
				else
				{
					src = fpip->ycp_edit;
					dst = fpip->ycp_temp;
				}
				for(int y = 1 ; y < height; ++y)
				{
					int addr = y * pitch;
					#pragma omp parallel for
					for( int x = 1 ; x < width ; ++x )
					{
						int cc = addr + x;
						int pc = cc - pitch;
						int pp = pc-1;
						int pn = pc+1;
						int cp = cc -1;
						int cn = cc +1;
						int nc = cc + pitch;
						int np = nc-1;
						int nn = nc+1;

						dst[ cc ].y  = Round< short, 0, 4096 >( 
							ishophote3(
								src[ pp ].y , src[ pc ].y , src[ pn ].y,
								src[ cp ].y , src[ cc ].y , src[ cn ].y, 
								src[ np ].y , src[ nc ].y , src[ nn ].y, Step )
							);
					}
				
				}
			}//itr
		
		}// mode 3

	}
	else
	{
		#pragma omp parallel
		#pragma omp sections
		{
			#pragma omp section
			{
				memcpy( fpip->ycp_temp, fpip->ycp_edit, sizeof( PIXEL_YC )*fpip->w );
			}
			#pragma omp section
			{
				int offset = fpip->max_w*(fpip->h-1);
				memcpy( fpip->ycp_temp+offset, fpip->ycp_edit+offset, sizeof( PIXEL_YC )*fpip->w );
			}
			#pragma omp section
			{
				const int width = fpip->w-1;
				#pragma omp parallel for
				for( int ly = 1; ly < fpip->h-1; ++ly )
				{
					const int y_pitch = fpip->max_w*ly;
					
					*(fpip->ycp_temp + y_pitch) = *(fpip->ycp_edit + y_pitch);;
					*(fpip->ycp_temp+  y_pitch + width ) = *(fpip->ycp_edit + y_pitch + width);
				
				}
			}
		}


		if( mode == 0 )
		{
			for(int i = 0 ; i<= iterations ; ++i)
			{
				if( i & 1 )
				{
					src = fpip->ycp_temp;
					dst = fpip->ycp_edit;
				}
				else
				{
					src = fpip->ycp_edit;
					dst = fpip->ycp_temp;
				}
				for(int y = 1 ; y < height; ++y)
				{

					int addr = y * pitch;
					#pragma omp parallel for
					for( int x = 1 ; x < width ; ++x )
					{
						int cc = addr + x;
						int pc = cc - pitch;
						int pp = pc-1;
						int pn = pc+1;
						int cp = cc -1;
						int cn = cc +1;
						int nc = cc + pitch;
						int np = nc-1;
						int nn = nc+1;

						dst[ cc ].y  = Round< short, 0, 4096 >( 
							ishophote1(
								src[ pp ].y , src[ pc ].y , src[ pn ].y,
								src[ cp ].y , src[ cc ].y , src[ cn ].y, 
								src[ np ].y , src[ nc ].y , src[ nn ].y, Step )
							);

						dst[ cc ].cr  = Round< short, -2048, 2048 >( 
							ishophote1(
								src[ pp ].cr , src[ pc ].cr , src[ pn ].cr,
								src[ cp ].cr , src[ cc ].cr , src[ cn ].cr, 
								src[ np ].cr , src[ nc ].cr , src[ nn ].cr, Step )
							);
						dst[ cc ].cb  = Round< short, -2048, 2048 >( 
							ishophote1(
								src[ pp ].cb , src[ pc ].cb , src[ pn ].cb,
								src[ cp ].cb , src[ cc ].cb , src[ cn ].cb, 
								src[ np ].cb , src[ nc ].cb , src[ nn ].cb, Step )
							);

					
					
					}
				
				}
			}
		}
		else if ( mode ==1 )
		{
			for(int i = 0 ; i<= iterations ; ++i)
			{
				if( i & 1 )
				{
					src = fpip->ycp_temp;
					dst = fpip->ycp_edit;
				}
				else
				{
					src = fpip->ycp_edit;
					dst = fpip->ycp_temp;
				}
				for(int y = 1 ; y < height; ++y)
				{
					int addr = y * pitch;
					#pragma omp parallel for
					for( int x = 1 ; x < width ; ++x )
					{
						int cc = addr + x;
						int pc = cc - pitch;
						int pp = pc-1;
						int pn = pc+1;
						int cp = cc -1;
						int cn = cc +1;
						int nc = cc + pitch;
						int np = nc-1;
						int nn = nc+1;

						dst[ cc ].y  = Round< short, 0, 4096 >( 
							ishophote2(
								src[ pp ].y , src[ pc ].y , src[ pn ].y,
								src[ cp ].y , src[ cc ].y , src[ cn ].y, 
								src[ np ].y , src[ nc ].y , src[ nn ].y, Step )
							);

						dst[ cc ].cr  = Round< short, -2048, 2048 >( 
							ishophote2(
								src[ pp ].cr , src[ pc ].cr , src[ pn ].cr,
								src[ cp ].cr , src[ cc ].cr , src[ cn ].cr, 
								src[ np ].cr , src[ nc ].cr , src[ nn ].cr, Step )
							);
						dst[ cc ].cb  = Round< short, -2048, 2048 >( 
							ishophote2(
								src[ pp ].cb , src[ pc ].cb , src[ pn ].cb,
								src[ cp ].cb , src[ cc ].cb , src[ cn ].cb, 
								src[ np ].cb , src[ nc ].cb , src[ nn ].cb, Step )
							);

					
					
					}
				
				}
			}
		
		}
		else
		{
			for(int i = 0 ; i<= iterations ; ++i)
			{
				if( i & 1 )
				{
					src = fpip->ycp_temp;
					dst = fpip->ycp_edit;
				}
				else
				{
					src = fpip->ycp_edit;
					dst = fpip->ycp_temp;
				}
				for(int y = 1 ; y < height; ++y)
				{
					int addr = y * pitch;
					#pragma omp parallel for
					for( int x = 1 ; x < width ; ++x )
					{
						int cc = addr + x;
						int pc = cc - pitch;
						int pp = pc-1;
						int pn = pc+1;
						int cp = cc -1;
						int cn = cc +1;
						int nc = cc + pitch;
						int np = nc-1;
						int nn = nc+1;

						dst[ cc ].y  = Round< short, 0, 4096 >( 
							ishophote3(
								src[ pp ].y , src[ pc ].y , src[ pn ].y,
								src[ cp ].y , src[ cc ].y , src[ cn ].y, 
								src[ np ].y , src[ nc ].y , src[ nn ].y, Step )
							);

						dst[ cc ].cr  = Round< short, -2048, 2048 >( 
							ishophote3(
								src[ pp ].cr , src[ pc ].cr , src[ pn ].cr,
								src[ cp ].cr , src[ cc ].cr , src[ cn ].cr, 
								src[ np ].cr , src[ nc ].cr , src[ nn ].cr, Step )
							);
						dst[ cc ].cb  = Round< short, -2048, 2048 >( 
							ishophote3(
								src[ pp ].cb , src[ pc ].cb , src[ pn ].cb,
								src[ cp ].cb , src[ cc ].cb , src[ cn ].cb, 
								src[ np ].cb , src[ nc ].cb , src[ nn ].cb, Step )
							);

					
					
					}
				
				}
			}
		
		}


	}
	{
		if( iterations & 1 )
		{
			PIXEL_YC* temp = fpip->ycp_temp;
			fpip->ycp_temp = fpip->ycp_edit;
			fpip->ycp_edit = temp;
		}	

	
	}

#ifdef GET_TIME
	GetThreadTimes( GetCurrentThread(), &dumy, &dumy, &dumy, &end);
	DWORD end_time = timeGetTime() ;
	timeEndPeriod( 1 ) ; 
	SYSTEMTIME stStart,stEnd;
	FileTimeToSystemTime( &start, &stStart);
	FileTimeToSystemTime( &end, &stEnd);

	std::stringstream ss;
	ss << "timeGetTime = " << end_time - start_time << "ms  GetThreadTimes=";
	ss << stEnd.wMilliseconds - stStart.wMilliseconds << "ms" << std::ends;
 
	::MessageBoxEx( fp->hwnd, ss.str().c_str() ,"",0,0);
#endif

	return TRUE;
}


